:- pce_autoload(finder, library(find_file)).
:- pce_global(@finder, new(finder)).
:- consult([turtle, logointerpreter]).

logo:-
  new(F, frame('Mini-LOGO')),
  send(F, append, new(D, dialog('Quelldatei'))),

  send(D, append, new(V, view)),

  send(D, append, button('Laden', message(@prolog, lade, V))),
  send(D, append, button('Ausfhren', message(@prolog, ausfuehren, V))),
  send(D, append, button('Beenden', message(D, destroy))),
  send(F, open).

lade(V):-
  get(@finder, file, @on, '.log', LogoDatei),
  send(V, print, 'Quelltext: '),
  send(V, load, LogoDatei),
  retractall(datei(_)),
  assert(datei(LogoDatei)).


ausfuehren(V):-  
  datei(LogoDatei),
  send(V, append, ''),
  send(V, newline),
  send(V, newline),
  see(LogoDatei),
  readln(Eingabe, _, '.', '0123456789', lowercase),
  seen,
  send(V, print, 'Vom Scanner erzeugte Symbolliste'),
  send(V, newline),
  send(V, print, '['),
  schreib_liste(V, Eingabe),
  send(V, print, ']'),
  send(V, newline),
  parse_logo(Eingabe, Parsebaum),
  zeichne_term(Parsebaum),
  turtle_init,
  asserta(turtle_penpos(down)),
  interpret_logo(Parsebaum).
  
schreib_liste(V, [Element]):-
  send(V, print, Element).
schreib_liste(V, [Kopf|Rest]):-
  send(V, print, Kopf),
  send(V, print, ', '),
  schreib_liste(V, Rest).

% send(@prolog, write, hello).


