/* Modul    : turtle.pl                                       */
/* Zweck    : Stellt eine Turtle fr Swing-Prolog bereit.     */
/* Autor    : Gerhard Rhner                                  */
/* Version  : 1.0, 16.11.99, Urfassung                        */
/* Copyright: (c) Gerhard Rhner, 1999-2000                   */

turtle_init:-
   % alten Zustand lschen
   retractall(turtle(_,_,_)),

   % neuen Zustand setzen
   B is 400,
   H is 300,
   B1 is B /2,
   H1 is H / 2,
   W1 is 0,
   assert(turtle(B1, H1, W1)),
   
   % altes turtle-Fenster schlieen
   free(@turtle),

   % neues turtle-Fenster ffnen
   new(@turtle, picture('turtle', size(B, H))), send(@turtle, open).

turtle_term:-
  retractall(turtle(_,_,_)),
  free(@turtle).

turtle_drawto(X, Y):-
  retract(turtle(X1, Y1, W)),
  send(@turtle, display, new(_, line(X1, Y1, X, Y))),
  assert(turtle(X, Y, W)).

turtle_draw(L):-
  retract(turtle(X1, Y1, W)),
  X2 is X1 + L*cos(W*pi/180),
  Y2 is Y1 - L*sin(W*pi/180),
  send(@turtle, display, new(_, line(X1, Y1, X2, Y2))),
  assert(turtle(X2, Y2, W)).

turtle_turn(W):-
  retract(turtle(X, Y, W1)),
  W2 is W1 + W,
  assert(turtle(X, Y, W2)).

turtle_turnto(W):-
  retract(turtle(X, Y, _)),
  assert(turtle(X, Y, W)).

turtle_move(L):-
  retract(turtle(X1, Y1, W)),
  X2 is X1 + L*cos(W*pi/180),
  Y2 is Y1 - L*sin(W*pi/180),
  assert(turtle(X2, Y2, W)).

turtle_moveto(X, Y):-
  retract(turtle(_, _, W)),
  assert(turtle(X, Y, W)).

